

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">

  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <title>Keystore Provisioning &mdash; TISCI User Guide</title>




    <link rel="shortcut icon" href="../_static/favicon.ico"/>












    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />



    <link rel="stylesheet" href="../_static/theme_overrides.css" type="text/css" />



        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../index.html"/>
        <link rel="up" title="Chapter 6: Topic User Guides" href="index.html"/>
        <link rel="next" title="Asymmetric Key Services" href="asymmetric_key_services.html"/>
        <link rel="prev" title="Signing binaries for Secure Boot" href="secure_boot_signing.html"/>


  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">


    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">



            <a href="../index.html" class="icon icon-home"> TISCI



          </a>




              <div class="version">
                19.07.00
              </div>




<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>


        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">



                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="../2_tisci_msgs/index.html">Chapter 2: TISCI Message Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Chapter 6: Topic User Guides</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="secure_boot_signing.html">Signing binaries for Secure Boot</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Keystore Provisioning</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#creating-the-keystore-structure">Creating the keystore structure</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#data-structures">Data structures</a></li>
<li class="toctree-l4"><a class="reference internal" href="#bigint-data-format">BIGINT data format</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#encrypting-and-signing-the-keystore-contents">Encrypting and signing the keystore contents</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="asymmetric_key_services.html">Asymmetric Key Services</a></li>
</ul>
</li>
</ul>



        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">


      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../index.html">TISCI</a>
      </nav>



      <div class="wy-nav-content">
        <div class="rst-content">






<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../index.html">Docs</a> &raquo;</li>

          <li><a href="index.html">Chapter 6: Topic User Guides</a> &raquo;</li>

    <li>Keystore Provisioning</li>
      <li class="wy-breadcrumbs-aside">



      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">

  <div class="section" id="keystore-provisioning">
<span id="pub-keystore-provision"></span><h1>Keystore Provisioning<a class="headerlink" href="#keystore-provisioning" title="Permalink to this headline">¶</a></h1>
<p>This document contains the information needed to generate the payload contents
used by the <a class="reference internal" href="../2_tisci_msgs/security/keystore.html#keystore-write"><span class="std std-ref">TISCI_MSG_KEYSTORE_WRITE</span></a> API for initial
keystore provisioning.</p>
<ol class="arabic simple">
<li><a class="reference internal" href="#create-keystore"><span class="std std-ref">Creating the keystore structure</span></a></li>
<li><a class="reference internal" href="#enc-sign-keystore"><span class="std std-ref">Encrypting and signing the keystore contents</span></a></li>
</ol>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Runtime keystore in System Firmware is maintained through a data structure in DMSC
internal memory. All keys are stored in plaintext form for internal use by
various runtime key services and are only ever exposed externally in encrypted
form. In addition to the key parameters, additional metadata is managed,
including individual key slot ownership and usage permissions, which key slots
contain valid keys, keystore partitioning details, and internal state
information.</p>
<p>The system designer is responsible for establishing a root of trust with the
device to unlock the keystore for provisioning of initial contents. This
action includes:</p>
<ul class="simple">
<li>Injecting primary set of keys</li>
<li>Specifying permissions for all key slots</li>
<li>Assigning ownership for the keystore structure</li>
</ul>
</div>
<div class="section" id="creating-the-keystore-structure">
<span id="create-keystore"></span><h2>Creating the keystore structure<a class="headerlink" href="#creating-the-keystore-structure" title="Permalink to this headline">¶</a></h2>
<p>Keystore contents will be written directly into System Firmware internal memory using
the keystore write API. The data must be be packed into a structure which is
understood by System Firmware and is defined below. The user is responsible for creating
this structure in their own HSM.</p>
<div class="section" id="data-structures">
<h3>Data structures<a class="headerlink" href="#data-structures" title="Permalink to this headline">¶</a></h3>
<p>The below data structures represent the keystore and various key data and
metadata it contains. Keystore write payload (in plaintext form) must match this
format to guarantee that System Firmware internally can comprehend the same structure
and use to properly reference for subsequent key operations.</p>
<p>The following sections describe in detail the structues used in the keystore:</p>
<table border="1" class="docutils">
<colgroup>
<col width="47%" />
<col width="53%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Structure</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><a class="reference internal" href="#keystore-state-def"><span class="std std-ref">keystore_state</span></a></td>
<td>Definition of keystore holding all keys and metadata</td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#keystore-key-cfg-def"><span class="std std-ref">keystore_key_cfg</span></a></td>
<td>Metadata for each key index in the keystore</td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#rsa-privkey-def"><span class="std std-ref">rsa_privkey</span></a></td>
<td>RSA private key</td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#rsa-pubkey-def"><span class="std std-ref">rsa_pubkey</span></a></td>
<td>RSA public key</td>
</tr>
<tr class="row-even"><td><a class="reference internal" href="#ec-pubkey-def"><span class="std std-ref">ec_pubkey</span></a></td>
<td>EC public key</td>
</tr>
<tr class="row-odd"><td><a class="reference internal" href="#ec-privkey-def"><span class="std std-ref">ec_privkey</span></a></td>
<td>EC private key</td>
</tr>
</tbody>
</table>
<div class="section" id="keystore-state">
<span id="keystore-state-def"></span><h4>Keystore State<a class="headerlink" href="#keystore-state" title="Permalink to this headline">¶</a></h4>
<p>The keystore state structure contains a collection of user keys, key metadata,
and keystore information. It is statically defined to hold a predetermined
amount of symmetric and asymmetric key slots which are allocated for their
worst-case memory size:</p>
<ul class="simple">
<li>Symmetric key slots are 32 bytes to accommodate up to 256-bit keys and are
used to hold any symmetric key size/type</li>
<li>Asymmetric key slots are 2400 bytes to accommodate up to 4K RSA private key
parameters and are used to hold all RSA/EC public or private keys</li>
</ul>
<p>The below shows how keystore is currently defined in System Firmware:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * \brief Module global state</span>
<span class="cm"> *</span>
<span class="cm"> * \param skey_cfg Symmetric key host/usage permissions</span>
<span class="cm"> * \param skey_status Symmetric key import status</span>
<span class="cm"> * \param skey Symmetric key value imported</span>
<span class="cm"> * \param askey_cfg Asymmetric key host/usage permissions</span>
<span class="cm"> * \param askey_status Asymmetric key import status</span>
<span class="cm"> * \param askey_type Asymmetric key type (rsa or ec)</span>
<span class="cm"> * \param askey Asymmetric key value imported</span>
<span class="cm"> * \param owner Host ID of the host who owns the keystore structure. The</span>
<span class="cm"> *              ownership will be determined during key provisioning through the</span>
<span class="cm"> *              payload details contained in the keystore write API. Only the</span>
<span class="cm"> *              owner will be able to trigger bulk keystore export and import.</span>
<span class="cm"> * \param reserved Reserved</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="p">{</span>
      <span class="k">struct</span> <span class="n">keystore_key_cfg</span> <span class="n">skey_cfg</span><span class="p">[</span><span class="n">KEYSTORE_NUM_SKEYS_MAX</span><span class="p">];</span>
      <span class="n">u8</span>                      <span class="n">skey_status</span><span class="p">[</span><span class="n">KEYSTORE_NUM_SKEYS_MAX</span><span class="p">];</span>
      <span class="n">u8</span>                      <span class="n">skey</span><span class="p">[</span><span class="n">KEYSTORE_NUM_SKEYS_MAX</span><span class="p">][</span>
              <span class="n">KEYSTORE_SKEY_KEY_LEN</span><span class="p">];</span>
      <span class="k">struct</span> <span class="n">keystore_key_cfg</span> <span class="n">askey_cfg</span><span class="p">[</span><span class="n">KEYSTORE_NUM_ASKEYS_MAX</span><span class="p">];</span>
      <span class="n">u8</span>                      <span class="n">askey_status</span><span class="p">[</span><span class="n">KEYSTORE_NUM_ASKEYS_MAX</span><span class="p">];</span>
      <span class="n">u8</span>                      <span class="n">askey_type</span><span class="p">[</span><span class="n">KEYSTORE_NUM_ASKEYS_MAX</span><span class="p">];</span>
      <span class="k">union</span> <span class="p">{</span>
              <span class="k">struct</span> <span class="n">rsa_privkey</span>      <span class="n">rsa</span><span class="p">;</span>
              <span class="k">struct</span> <span class="n">rsa_pubkey</span>       <span class="n">rsa_pub</span><span class="p">;</span>
              <span class="k">struct</span> <span class="n">ec_privkey</span>       <span class="n">ec</span><span class="p">;</span>
              <span class="k">struct</span> <span class="n">ec_pubkey</span>        <span class="n">ec_pub</span><span class="p">;</span>
      <span class="p">}</span> <span class="n">askey</span><span class="p">[</span><span class="n">KEYSTORE_NUM_ASKEYS_MAX</span><span class="p">];</span>
      <span class="n">u8</span>      <span class="n">owner</span><span class="p">;</span>
      <span class="n">u8</span>      <span class="n">reserved</span><span class="p">;</span>
<span class="p">}</span> <span class="n">keystore_state</span><span class="p">;</span>
</pre></div>
</div>
<p>Some size and number macro definitions are listed below to fill in details on
the size of each of the arrays:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * Maximum number of imported symmetric keys</span>
<span class="cm"> */</span>
<span class="cp">#define KEYSTORE_NUM_SKEYS_MAX           (8U)</span>

<span class="cm">/** Key size used for symmetric key store */</span>
<span class="cp">#define KEYSTORE_SKEY_KEY_LEN            (32U)</span>

<span class="cm">/* Maximum number of asymmetric keys */</span>
<span class="cp">#define KEYSTORE_NUM_ASKEYS_MAX          (4U)</span>
</pre></div>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The macros indicating the size are temporary and only relevant in the context
of statically-partitioned keystore memory.  When the keystore supports the
runtime configuration of partitioning then the above macros will become
obsolete.</p>
</div>
<p><cite>skey_status</cite> and <cite>askey_status</cite> defines whether the key slot holds a valid key
or not. If the key slot does not contains a key, it is set to zero.  If the slot
contains a valid key, it must be initialized with the special value below:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * flag indicating if the key import status was OK</span>
<span class="cm"> */</span>
<span class="cp">#define KEYSTORE_KEY_IMPORT_STATUS_OK          0x5AU</span>
</pre></div>
</div>
<p>Asymmetric keys are distinguished with the <cite>askey_type</cite> parameter below:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/* Public key crypto algo types */</span>
<span class="cp">#define PK_TYPE_RSA                       0</span>
<span class="cp">#define PK_TYPE_EC                        1</span>
</pre></div>
</div>
</div>
<div class="section" id="keystore-key-config">
<span id="keystore-key-cfg-def"></span><h4>Keystore Key Config<a class="headerlink" href="#keystore-key-config" title="Permalink to this headline">¶</a></h4>
<p>The <cite>keystore_key_cfg</cite> determines host access and usage permissions for each key
slot. The definition is as follows:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * \brief Configuration info for one key item</span>
<span class="cm"> *</span>
<span class="cm"> * \struct keystore_key_cfg</span>
<span class="cm"> *</span>
<span class="cm"> * \param owner Owner of this item</span>
<span class="cm"> * \param usage_flags Or&#39;ed value of KEYSTORE_[AS]KEY_USAGE* flags</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">keystore_key_cfg</span> <span class="p">{</span>
      <span class="n">u8</span>      <span class="n">owner</span><span class="p">;</span>
      <span class="n">u32</span>     <span class="n">usage_flags</span><span class="p">;</span>
<span class="p">}</span> <span class="n">__attribute__</span><span class="p">((</span><span class="n">packed</span><span class="p">));</span>
</pre></div>
</div>
<p><cite>owner</cite> is the Host ID. Host ownership is assigned to each individual key slot to
limit operations using the keys based on a host identifier.  This contrasts
<cite>owner</cite> of the keystore structure which determines who will be able to
export/import the entire keystore contents. See specific Host ID enumerations
for the particular <a class="reference internal" href="../5_soc_doc/index.html#pub-soc-family-doc"><span class="std std-ref">SoC family of interest</span></a> for details
on valid values.</p>
<p><cite>usage_flags</cite> are a bitwise-OR of various operation types defined for symmetric
and asymmetric keys. Each key slot may be specified to restrict usage to some
or all of the operations as defined below.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Key usage permissions are not fully defined at this time and will be
introduced in a later release. All keys are to remain available for all usage
types until further specified. Until then, <cite>usage_flags</cite> will be ignored and
should be programmed with <strong>all bits set to 1</strong> to protect for future
compatibility:</p>
</div>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/* Flag indicating that the key is open for all usages */</span>
<span class="cp">#define KEYSTORE_USAGE_FLAGS_ALL_OPEN     (0xFFFFFFFFU)</span>
</pre></div>
</div>
</div>
<div class="section" id="rsa-private-key">
<span id="rsa-privkey-def"></span><h4>RSA Private Key<a class="headerlink" href="#rsa-private-key" title="Permalink to this headline">¶</a></h4>
<p>The following provides a description of the RSA private key parameters:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/* RSA keys */</span>
<span class="cp">#define RSA_KEY_E_MAXLEN                  (8U)</span>
<span class="cp">#define RSA_KEY_N_MAXLEN                  (520U)</span>
<span class="cp">#define RSA_KEY_PQ_MAXLEN                 ((RSA_KEY_N_MAXLEN / 2U) + 4U)</span>

<span class="cm">/**</span>
<span class="cm"> * \brief RSA private key. All values are in biginteger format (size followed</span>
<span class="cm"> *        by word value array, least significant word first)</span>
<span class="cm"> *</span>
<span class="cm"> * \param n RSA modulus (n)</span>
<span class="cm"> * \param e Public exponent (e)</span>
<span class="cm"> * \param d Private exponent (d)</span>
<span class="cm"> * \param p Prime 1 (p)</span>
<span class="cm"> * \param q Prime 2 (q)</span>
<span class="cm"> * \param dp d mod (p-1)</span>
<span class="cm"> * \param dq d mod (q-1)</span>
<span class="cm"> * \param coefficient crt coefficient q^(-1) mod p</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">rsa_privkey</span> <span class="p">{</span>
      <span class="n">u32</span>     <span class="n">n</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_N_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">e</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_E_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">d</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_N_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">p</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_PQ_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">q</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_PQ_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">dp</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_PQ_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">dq</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_PQ_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">coefficient</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_PQ_MAXLEN</span><span class="p">)];</span>
<span class="p">};</span>
</pre></div>
</div>
</div>
<div class="section" id="rsa-public-key">
<span id="rsa-pubkey-def"></span><h4>RSA Public Key<a class="headerlink" href="#rsa-public-key" title="Permalink to this headline">¶</a></h4>
<p>The following provides a description of the RSA public key parameters:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * \brief RSA public key. All values are in biginteger format (size followed</span>
<span class="cm"> *        by word value array, least significant word first)</span>
<span class="cm"> *</span>
<span class="cm"> * \param n RSA modulus (n)</span>
<span class="cm"> * \param e Public exponent (e)</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">rsa_pubkey</span> <span class="p">{</span>
      <span class="n">u32</span>     <span class="n">n</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_N_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">e</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">RSA_KEY_E_MAXLEN</span><span class="p">)];</span>
<span class="p">};</span>
</pre></div>
</div>
</div>
<div class="section" id="ec-public-key">
<span id="ec-pubkey-def"></span><h4>EC Public Key<a class="headerlink" href="#ec-public-key" title="Permalink to this headline">¶</a></h4>
<p>The following provides a description of the EC public key parameters:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * Maximum length of a big integer used in EC crypto in bytes, enough to</span>
<span class="cm"> * accomodate 521-bit prime curves</span>
<span class="cm"> */</span>
<span class="cp">#define EC_PARAM_MAXLEN                 (68U)</span>

<span class="cm">/* ECDSA known curves */</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P256R1         0</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P256T1         1</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P320R1         2</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P320T1         3</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P384R1         4</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P384T1         5</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P512R1         6</span>
<span class="cp">#define EC_CURVE_BRAINPOOL_P512T1         7</span>
<span class="cp">#define EC_CURVE_PRIME256V1               8</span>
<span class="cp">#define EC_CURVE_SECP256K1                9</span>
<span class="cp">#define EC_CURVE_SECP384R1                10</span>
<span class="cp">#define EC_CURVE_SECP521R1                11</span>
<span class="cp">#define EC_CURVE_N_ITEMS                  12</span>

<span class="cp">#define EC_CURVE_EXPLICIT                (-1)</span>

<span class="cm">/**</span>
<span class="cm"> * \brief EC prime curve parameters</span>
<span class="cm"> *</span>
<span class="cm"> * \param prime Prime number for the group</span>
<span class="cm"> * \param order Order of the group</span>
<span class="cm"> * \param a &quot;a&quot; parameter in the equation x^3 + ax + b = y</span>
<span class="cm"> * \param b &quot;b&quot; parameter in the equation x^3 + ax + b = y</span>
<span class="cm"> * \param g Generator point on the Elliptic curve</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">ec_prime_curve_p</span> <span class="p">{</span>
      <span class="n">u32</span>             <span class="n">prime</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>             <span class="n">order</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>             <span class="n">a</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>             <span class="n">b</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
      <span class="k">struct</span> <span class="n">ec_point</span> <span class="n">g</span><span class="p">;</span>
<span class="p">};</span>

<span class="cm">/**</span>
<span class="cm"> * \brief EC Point, also the public key</span>
<span class="cm"> *</span>
<span class="cm"> * \param x x-coordinate</span>
<span class="cm"> * \param y y-coordinate</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">ec_point</span> <span class="p">{</span>
      <span class="n">u32</span>     <span class="n">x</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
      <span class="n">u32</span>     <span class="n">y</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
<span class="p">};</span>

<span class="cm">/*</span>
<span class="cm"> * \brief EC public key</span>
<span class="cm"> *</span>
<span class="cm"> * \param ec_curve_type One of EC_CURVE_* types</span>
<span class="cm"> * \param curve_params EC Curve parameters</span>
<span class="cm"> * \param public_key Public key value</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">ec_pubkey</span> <span class="p">{</span>
      <span class="n">s32</span>                     <span class="n">ec_curve_type</span><span class="p">;</span>
      <span class="k">struct</span> <span class="n">ec_prime_curve_p</span> <span class="n">curve_params</span><span class="p">;</span>
      <span class="k">struct</span> <span class="n">ec_point</span>         <span class="n">public_curve_point</span><span class="p">;</span>
<span class="p">};</span>
</pre></div>
</div>
</div>
<div class="section" id="ec-private-key">
<span id="ec-privkey-def"></span><h4>EC Private Key<a class="headerlink" href="#ec-private-key" title="Permalink to this headline">¶</a></h4>
<p>The following provides a description of the EC private key parameters:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/*</span>
<span class="cm"> * \brief EC private key</span>
<span class="cm"> *</span>
<span class="cm"> * \param ec_curve_type One of EC_CURVE_* types</span>
<span class="cm"> * \param curve_params EC Curve parameters</span>
<span class="cm"> * \param private_key Private key value</span>
<span class="cm"> * \param public_key Public key value</span>
<span class="cm"> */</span>
<span class="k">struct</span> <span class="n">ec_privkey</span> <span class="p">{</span>
      <span class="n">s32</span>                     <span class="n">ec_curve_type</span><span class="p">;</span>
      <span class="k">struct</span> <span class="n">ec_prime_curve_p</span> <span class="n">curve_params</span><span class="p">;</span>
      <span class="n">u32</span>                     <span class="n">private_key</span><span class="p">[</span><span class="n">BIGINT_LEN</span><span class="p">(</span><span class="n">EC_PARAM_MAXLEN</span><span class="p">)];</span>
      <span class="k">struct</span> <span class="n">ec_point</span>         <span class="n">public_curve_point</span><span class="p">;</span>
<span class="p">};</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="bigint-data-format">
<span id="id1"></span><h3>BIGINT data format<a class="headerlink" href="#bigint-data-format" title="Permalink to this headline">¶</a></h3>
<p>Asymmetric key operations are performed by a Public Key Accelerator (PKA)
hardware module which expects key parameters and input/output data blocks to be
in a particular format in order to generalize the operations across all key
types and sizes. System Firmware enforces the data format referred to as BIGINT in order
to facilitate translation of these parameters to the PKA module.</p>
<p>BIGINT is a series of 32-bit words used to represent a little-endian byte stream
and the size of the stream. The first word will contain the size of the byte
stream in words, i.e.:</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="n">ceil</span><span class="p">(</span><span class="n">number_of_bytes_in_stream</span> <span class="o">/</span> <span class="mi">4</span><span class="p">)</span>
</pre></div>
</div>
<p>Following the size word will be an array of words holding the LE byte array. An
example below shows a 10-byte data block in bytes and again in BIGINT format.
Note that the byte array is padded with extra zeros in the MSBs if it is too
small to completely fill the last BIGINT array slot.</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/* Data block shown as a byte stream */</span>
<span class="n">u8</span> <span class="n">data_block</span><span class="p">[]</span> <span class="o">=</span> <span class="p">{</span><span class="mh">0x00</span><span class="p">,</span> <span class="mh">0x11</span><span class="p">,</span> <span class="mh">0x22</span><span class="p">,</span> <span class="mh">0x33</span><span class="p">,</span> <span class="mh">0x44</span><span class="p">,</span> <span class="mh">0x55</span><span class="p">,</span> <span class="mh">0x66</span><span class="p">,</span> <span class="mh">0x77</span><span class="p">,</span> <span class="mh">0x88</span><span class="p">,</span> <span class="mh">0x99</span><span class="p">};</span>

<span class="cm">/* Same data in BIGINT format:</span>
<span class="cm"> *   First word is the size = ceil(10/4) = 3</span>
<span class="cm"> *   Next 3 words contain the byte data (little endian)</span>
<span class="cm"> *   Last word padded with zeros to fill unused data</span>
<span class="cm"> */</span>
<span class="n">u32</span> <span class="n">data_block_bigint</span><span class="p">[]</span> <span class="o">=</span> <span class="p">{</span><span class="mh">0x3</span><span class="p">,</span> <span class="mh">0x33221100</span><span class="p">,</span> <span class="mh">0x77665544</span><span class="p">,</span> <span class="mh">0x00009988</span><span class="p">};</span>
</pre></div>
</div>
<p>In general, for a given byte array, the BIGINT array size will be</p>
<div class="highlight-c"><div class="highlight"><pre><span></span><span class="cm">/**</span>
<span class="cm"> * Length of a biginteger array in words, the +1 is for the size</span>
<span class="cm"> */</span>
<span class="cp">#define BIGINT_LEN(bytelen)              (((bytelen + 3) / 4U) + 1U)</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="encrypting-and-signing-the-keystore-contents">
<span id="enc-sign-keystore"></span><h2>Encrypting and signing the keystore contents<a class="headerlink" href="#encrypting-and-signing-the-keystore-contents" title="Permalink to this headline">¶</a></h2>
<p><a class="reference internal" href="../2_tisci_msgs/security/keystore.html#keystore-write"><span class="std std-ref">TISCI_MSG_KEYSTORE_WRITE</span></a> payload requires that the
keystore contents be encrypted and signed. Successful validation and decryption
of the payload will unlock the keystore for writing to the internal structure.
The process for encrypting and signing mirrors how one <a class="reference internal" href="secure_boot_signing.html#pub-sign-encrypted-mek"><span class="std std-ref">signs an encrypted
binary for secure boot</span></a>.</p>
<ol class="arabic simple">
<li>Pad the binary with zeros until the length is a multiple of 16 bytes.</li>
<li>Append a 32 byte long random string to the binary output in step (1). This
random string is used by System Firmware to verify successful decryption. This string
needs to be populated in the X509 certificate.</li>
<li>Choose 16 byte long random string as the initialization vector(IV) for CBC
encryption. This string also needs to be populated in the X509 certificate.</li>
<li>Choose the key to encrypt the binary. System Firmware only supports
encryption with the active MEK.</li>
<li>Encrypt the binary output from step (2) with key chosen in step (4) in
AES-256-CBC mode. Use the string chosen in step (3) as the initialization
vector.</li>
</ol>
<p>When using encryption, the X509 encryption extension needs to be populated in
the certificate before signing. The following changes apply to the other extensions.</p>
<ol class="arabic simple">
<li>The length of binary output in step (2) above needs to be populated in the
X509 image integrity extension.</li>
<li>The binary output of step (5) needs to be used when calculating the hash to be
populated in the X509 image integrity extension.</li>
<li>The binary output of step (5) must be appended to the signed X509 certificate
instead of the unencrypted binary.</li>
</ol>
<p>Please refer to <a class="reference internal" href="../2_tisci_msgs/security/sec_cert_format.html#sysfw-image-integrity-ext"><span class="std std-ref">System Firmware Image Integrity Extension</span></a> and <a class="reference internal" href="../2_tisci_msgs/security/sec_cert_format.html#sysfw-encryption-ext"><span class="std std-ref">System Firmware Encryption Extension</span></a>.</p>
</div>
</div>


           </div>
          </div>
          <footer>

    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">

        <a href="asymmetric_key_services.html" class="btn btn-neutral float-right" title="Asymmetric Key Services" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>


        <a href="secure_boot_signing.html" class="btn btn-neutral" title="Signing binaries for Secure Boot" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>

    </div>


  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2019</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div>

</footer>

        </div>
      </div>

    </section>

  </div>





    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'19.07.00',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>





    <script type="text/javascript" src="../_static/js/theme.js"></script>




  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>


</body>
</html>